Package: FossilSimShiny
Title: Shiny Application for 'FossilSim'
Version: 1.1.2
Authors@R: c(person("Titouan", "Chambe", email="titouan.chambe@u-psud.fr", role=c("aut")),
    person("Joelle", "Barido-Sottani", email="joelle.barido-sottani@m4x.org",role=c("aut","cre","cph")),
    person("Rachel", "Warnock", email="rachel.warnock@fau.de", role=c("aut","cph"))
    )
Description: A shiny application based on 'FossilSim'. Used for simulating
    tree, taxonomic and fossil data under mechanistic models of speciation,
    preservation and sampling.
License: GPL (>= 3)
Encoding: UTF-8
RoxygenNote: 7.1.2
Imports: shiny (>= 1.7.1), shinyjs, FossilSim, TreeSim
Suggests: knitr, rmarkdown, spelling
VignetteBuilder: knitr
Language: en-US
NeedsCompilation: no
Packaged: 2024-04-29 11:24:28 UTC; barid
Author: Titouan Chambe [aut],
  Joelle Barido-Sottani [aut, cre, cph],
  Rachel Warnock [aut, cph]
Maintainer: Joelle Barido-Sottani <joelle.barido-sottani@m4x.org>
Repository: CRAN
Date/Publication: 2024-04-29 11:40:02 UTC
Built: R 4.6.0; ; 2026-04-25 13:42:05 UTC; unix

## FossilSimShiny

`R` package for exploring phylogenetic trees, taxonomy and fossil data simulations using a simple shiny interface.

The latest version can be installed in `R` using the package `devtools`:

```{R, eval = FALSE}
  library(devtools)
  install_github("fossilsim/shiny")
```

### Quick start

Launch the application using `FossilSimShiny::launchFossilSimShiny()`.

# Input Sidebar : Sidebar on the left side of the app where you make all your inputs ----

# Sidebar UI --- ---
inputSidebarUI <- function(id) {
  
  # Wrapping our ids ---
  # The NS function allows us to wrap the ids of our ui components
  # This is necessary for nested R modules like this one
  # ns stands for namespace, more info : https://shiny.rstudio.com/articles/modules.html
  ns <- NS(id)
  
  # Start of our UI ---
  # tagList is the nested version of fluidPage
  tagList(
    
    # Loading ---
    fixedPanel(id = "loader-wrapper",
               tags$div(id = "loader", "")
    ),
    
    sidebarPanel(
      
      HTML("</br>"),
      
      # I. Tree Simulation Inputs ---
      
      actionButton(ns("treetab-button"), h3("Tree"), class = "protobutton"),
      
      tags$div(id = ns("treetab-content"), class = "prototab prototabhidden",
               
               HTML("</br>"),
               
               # "Simulate tree" option --- 
               numericInput(inputId = ns("lambda"), # input name
                            label = "Speciation rate",  # user instructions
                            value = 0.1,
                            min = 0,                    # input specific arguments
                            max = 10 ),
               
               numericInput(inputId = ns("mu"),
                            label = "Extinction rate",
                            value = 0.05,
                            min = 0,
                            max = 10 ),
               
               numericInput(inputId = ns("tips"),
                            label = "Tip number",
                            value = 10,
                            min = 0,
                            max = 100 ),
               
               actionButton(ns("simtree"), "Simulate tree"),
               
               HTML("</br> </br>"),
               
               # "user tree" option --- 
               textInput(inputId = ns("newick"), "User tree",
                         value = "Enter newick string..."),
               
               actionButton(ns("usertree"), "Import tree"),
               
      ),
      # ---<
      
      HTML("</br>"),
      
      # II. Taxonomy Simulation Inputs ---     
      
      actionButton(ns("taxtab-button"), h3("Taxonomy"), class = "protobutton"),
      
      tags$div(id = ns("taxtab-content"), class = "prototab prototabhidden",
               
               HTML("</br>"),
               
               numericInput(inputId = ns("taxonomybeta"), 
                            label = "Probability of symmetric speciation", 
                            value = 0.1,
                            min = 0,
                            max = 10 ),
               
               numericInput(inputId = ns("taxonomylambda"),
                            label = "Rate of anagenesis",
                            value = 0.1,
                            min = 0,
                            max = 10 ),
               
               actionButton(ns("simtax"), "Simulate taxonomy"),
               actionButton(ns("cleartax"), "Clear taxonomy"),
               
      ),
      # ---<
      
      HTML("</br>"),
      
      # III. Fossil Sim Inputs ---
      
      actionButton(ns("fossiltab-button"), h3("Fossils"), class = "protobutton"),
      
      tags$div(id = ns("fossiltab-content"), class = "prototab prototabhidden",
               
               HTML("</br>"),
               
               # Multiple panel : every type of fossil simulation has its panel
               #todo -- add more type of fossil simulations
               #warning -- subject to change
               tabsetPanel(id = ns("tabset"), 
                           
                           # i. Uniform Distribution --
                           tabPanel(p("Uniform", id = ns("uniform")),
                                    HTML("</br>"),
                                    numericInput(inputId = ns("uniform-psi"),
                                                 label = "Sampling rate",
                                                 value = 1,
                                                 min = 0,
                                                 max = 10 )
                           ), 
                           # --<
                           
                           # ii. Non-uniform Distribution --
                           tabPanel(p("Time-dependent", id = ns("non-uniform")),
                                    HTML("</br>"),
                                    selectInput(ns("nonUniformType"), label = "Interval type", choices = c("random", "even", "user-defined")),
                                    
                                    conditionalPanel("input.nonUniformType == 'random' || input.nonUniformType == 'even'",
                                                     sliderInput(inputId = ns("non-uniform-int"), label = "Number of intervals", value = 1, min = 0, max = 10 ), 
                                                     ns = ns),
                                    conditionalPanel("input.nonUniformType == 'user-defined'",
                                                     textInput(inputId = ns("non-uniform-bounds"), label = "Interval bounds (delimited by /)"), 
                                                     ns = ns),
                                    
                                    numericInput(inputId = ns("non-uniform-meanrate"),
                                                 label = "Mean sampling rate",
                                                 value = 1,
                                                 min = 0,
                                                 max = 10 ),
                                    
                                    numericInput(inputId = ns("non-uniform-variance"),
                                                 label = "Variance",
                                                 value = 1,
                                                 min = 0,
                                                 max = 10 )
                           ),
                           # --<
                           
                           # iii. Environment Model (Holland, 1995) --
                           tabPanel(p("Depth-dependent", id = ns("enviro-dep")),
                                    HTML("</br>"),
                                    numericInput(inputId = ns("enviro-dep-strata"),
                                                 label = "Strata",
                                                 value = 7,
                                                 min = 1,
                                                 max = 10 ),
                                    
                                    numericInput(inputId = ns("enviro-dep-pd"),
                                                 label = "Preferred depth (PD)",
                                                 value = 0.5,
                                                 min = 0,
                                                 max = 10 ),
                                    
                                    numericInput(inputId = ns("enviro-dep-dt"),
                                                 label = "Depth tolerance (DT)",
                                                 value = 1,
                                                 min = 0,
                                                 max = 10 ),
                                    
                                    numericInput(inputId = ns("enviro-dep-pa"),
                                                 label = "Peak abundance (PA)",
                                                 value = 1,
                                                 min = 0,
                                                 max = 10 ),
                           ),
                           # --<
                           
                           # iv. Lineage Dependent Model
                           tabPanel(p("Lineage-dependent", id = ns("lineage-dep")),
                                    HTML("</br>"),
                                    numericInput(inputId = ns("lineage-dep-LNrate"),
                                                 label = "Mean rate",
                                                 value = 0.5,
                                                 min = -10,
                                                 max = 3 ),
                                    numericInput(inputId = ns("lineage-dep-LNsd"),
                                                 label = "Standard deviation",
                                                 value = 0.7,
                                                 min = 0,
                                                 max = 5 ),
                           ),
                           
                           # --<
                           
               ),
               
               actionButton(ns("simfossils"), "Simulate fossils"),
               actionButton(ns("clearfossils"), "Clear fossils"),
      ),
      # ---<
      HTML("</br> </br> </br> </br> </br> </br>"),
      # IV. Appearance Toggles ---
      
      actionButton(ns("appearancetab-button"), h3("Appearance"), class = "protobutton"),
      
      tags$div(id = ns("appearancetab-content"), class = "prototab prototabhidden",
               
               HTML("</br>"),
               
               checkboxInput(inputId = ns("showtree"), "Show tree", value = TRUE),
               checkboxInput(inputId = ns("showtaxonomy"), "Show fossil taxonomy - (requires simulated taxonomy and fossils)", value = FALSE),
               checkboxInput(inputId = ns("showfossils"), "Show all occurrences - (requires simulated fossils)", value = TRUE),
               checkboxInput(inputId = ns("showranges"), "Show ranges - (requires simulated fossils)", value = FALSE),
               checkboxInput(inputId = ns("showstrata"), "Show strata used in simulating fossils", value = FALSE),
               checkboxInput(inputId = ns("showtips"), "Show tip labels", value = FALSE),
               checkboxInput(inputId = ns("reconstructed"), "Show reconstructed tree", value = FALSE),
               checkboxInput(inputId = ns("enviro-dep-showsamplingproxy"), "Show depth (requires fossils under a depth-dependent model)", value = FALSE),
               
      ),
      # ---<
      
      # V. Save Tree ---
      h3("Save your simulation"),
      
      downloadButton(ns("dldata"), "Download the data"),
      
      tags$script(src = "protodashboard.js"),
      # ---<
      
      # Import Js for loading animation
      tags$script(src = "loading.js")
      
    )
  )
}


# Server code --- ---
inputSidebarServer <- function(id, v) {
  moduleServer(
    id,
    
    function(input, output, session) {
      
      # List of all of our different inputs, incredibly useful to perform mass actions ---
      # Does not need to be reactive as we avoid creating new inputs during run time
      allNumericInputs = c("lambda", "mu", "tips", "taxonomylambda", "taxonomybeta", "uniform-psi", "non-uniform-int", "non-uniform-meanrate", "non-uniform-variance", "enviro-dep-strata", 
                           "enviro-dep-pd", "enviro-dep-dt", "enviro-dep-pa", "lineage-dep-LNrate", "lineage-dep-LNsd")
      allCheckboxInputs = c("showtree", "showtaxonomy", "showfossils", "showranges", "showstrata", "showtips", "reconstructed", "enviro-dep-showsamplingproxy")
      allTextInputs = c("newick")
      
      listOfTabs = list(unif = "<p id=\"inputSidebar-uniform\">Uniform</p>", timedep = "<p id=\"inputSidebar-non-uniform\">Time-dependent</p>",
                        envdep = "<p id=\"inputSidebar-enviro-dep\">Depth-dependent</p>", lindep = "<p id=\"inputSidebar-lineage-dep\">Lineage-dependent</p>")
      
      # Simulate tree function ---
      observeEvent(input$simtree, {
        v$current$error = FALSE
        
        if (v$current$mu/v$current$lambda >= 0.9) {
          v$current$error = TRUE
          v$current$errorMsg = "To avoid overloading the server, please keep the turnover under 0.9."
        }
        if(v$current$tips > 100) {
          v$current$error = TRUE
          v$current$errorMsg = "To avoid overloading the server, please keep the number of tips under 100."
        }
        validate(need(!v$current$error, v$current$errorMsg))
        
        initial.time = Sys.time()
        repeat {
          v$current$tree = try(TreeSim::sim.bd.taxa(input$tips, 1, input$lambda, input$mu)[[1]])
          if(class(v$current$tree) != "try-error") break
        }
        v$current$status = list(timing = Sys.time() - initial.time, msg = "")
        
        v$current$fossils = FossilSim::fossils()
        v$current$tax = NULL # set taxonomy to NULL to avoid issues as old taxonomy will very likely not line up with a new tree
        
        session$sendCustomMessage("loading", FALSE)
      })
      
      # Newick function ---
      observeEvent(input$usertree, {
        v$current$error = FALSE
        if (input$newick == "" || input$newick == "Enter newick string...") {
          v$current$error = TRUE
          v$current$errorMsg = "No tree found, please input the tree as Newick."
        }
        validate(need(!v$current$error, v$current$errorMsg))
        
        v$current$tree = try(ape::read.tree(text = input$newick))
        if(is.null(v$current$tree)) v$current$tree = try(ape::read.tree(text = paste0(input$newick, ";"))) #ape requires the final ';' for some reason
        
        if(class(v$current$tree) == "try-error") v$current$tree = NULL
        if(is.null(v$current$tree)) {
          v$current$error = TRUE
          v$current$errorMsg = "Could not read tree, please check the Newick string."
        }
        v$current$status = list(timing = -1, msg = "")
        
        v$current$fossils = FossilSim::fossils()
        v$current$tax = NULL # set taxonomy to NULL to avoid issues as old taxonomy will very likely not line up with a new tree
        validate(need(!v$current$error, v$current$errorMsg))
        
        session$sendCustomMessage("loading", FALSE)
      })
      
      # Simulate taxonomy function ---
      observeEvent(input$simtax, {
        v$current$error = FALSE
        if (is.null(v$current$tree)) {
          v$current$error = TRUE
          v$current$errorMsg = "No tree found, please simulate or input a tree first."
        }
        validate(need(!v$current$error, v$current$errorMsg))
        
        initial.time = Sys.time()
        v$current$tax = FossilSim::sim.taxonomy(tree = v$current$tree, input$taxonomybeta, input$taxonomylambda)
        if(!attr(v$current$fossils, "from.taxonomy")) v$current$fossils = FossilSim::reconcile.fossils.taxonomy(v$current$fossils, v$current$tax)
        else v$current$fossils = FossilSim::fossils()
        
        tmp = v$current$tax[, c("sp", "mode")]
        event_counts = table(tmp[!duplicated(tmp),]$mode)
        v$current$status = list(timing = Sys.time() - initial.time, 
                                msg = paste("Simulated:", event_counts["a"], "anagenetic events,", event_counts["b"], "budding events and", event_counts["s"]/2, "bifurcating events"))
        
        session$sendCustomMessage("loading", FALSE)
      })
      
      # Clear taxonomy
      observeEvent(input$cleartax, {
        v$current$tax = NULL
      })
      
      # Check that fossilization rates are not too high
      validateRates = function(rates) {
        if(any(rates > 10)) {
          v$current$error = TRUE
          v$current$errorMsg = "Current parameters lead to high fossil sampling rates. Please adjust or try again."
        }
        validate(need(!v$current$error, v$current$errorMsg))
      }
      
      # Simulate fossils function ---
      observeEvent(input$simfossils, {
        v$current$error = FALSE
        if (is.null(v$current$tree)) {
          v$current$error = TRUE
          v$current$errorMsg = "No tree found, please simulate or input a tree first."
        }
        validate(need(!v$current$error, v$current$errorMsg))
        
        # Here we check which fossil sim tab is selected and simulate fossils
        initial.time = Sys.time()
        
        # i. Uniform Distribution --
        if(input$tabset == listOfTabs$unif) {
          v$current$fossilModelName = "Uniform"
          v$current$fossils = FossilSim::sim.fossils.poisson(tree = v$current$tree, rate = input$`uniform-psi`)
        }
        # --<
        
        # ii. Non-Uniform Distribution --
        else if (input$tabset == listOfTabs$timedep) {
          max.age = FossilSim::tree.max(v$current$tree)
          
          if(input$nonUniformType == "random") {
            v$current$int.ages = c(0, sort(runif(input$`non-uniform-int` - 1, min = 0, max = max.age)), max.age)
          } else if(input$nonUniformType == "even") {
            v$current$int.ages = seq(0, max.age, length.out = input$`non-uniform-int` + 1)
          } else if(input$nonUniformType == "user-defined") {
            v$current$int.ages = sort(as.numeric(strsplit(input$`non-uniform-bounds`, "/")[[1]]))
            if(v$current$int.ages[1] > 0) v$current$int.ages = c(0, v$current$int.ages)
            if(v$current$int.ages[length(v$current$int.ages)] < max.age) v$current$int.ages = c(v$current$int.ages, max.age)
          }
            
          rates = rlnorm(length(v$current$int.ages) - 1, log(input$`non-uniform-meanrate`), sqrt(input$`non-uniform-variance`))
          validateRates(rates)
          v$current$fossilModelName = "Non-Uniform"
          v$current$fossils = FossilSim::sim.fossils.intervals(v$current$tree, interval.ages = v$current$int.ages, rates = rates)
        }
        # --<
        
        # iii. Environment Model (Holland, 1995) --
        else if (input$tabset == listOfTabs$envdep) {
          v$current$strata = input$`enviro-dep-strata`
          v$current$wd = FossilSim::sim.gradient(input$`enviro-dep-strata`)
          v$current$fossilModelName = "Holland"
          v$current$fossils = FossilSim::sim.fossils.environment(tree = v$current$tree,
                                                                 max.age = FossilSim::tree.max(v$current$tree),
                                                                 strata = input$`enviro-dep-strata`,
                                                                 proxy.data = v$current$wd,
                                                                 PD = input$`enviro-dep-pd`,
                                                                 DT = input$`enviro-dep-dt`, PA = input$`enviro-dep-pa`)
        }
        # --<
        
        # iv. Lineage Model --
        else if (input$tabset == listOfTabs$lindep) {
          dist = function() { rlnorm(1, log(input$`lineage-dep-LNrate`), input$`lineage-dep-LNsd`) }
          rates = FossilSim::sim.trait.values(dist(), tree = v$current$tree, taxonomy = v$current$tax, model = "independent", dist = dist)
          validateRates(rates)
          v$current$fossilModelName = "Lineage"
          v$current$fossils = FossilSim::sim.fossils.poisson(rates, tree = v$current$tree, taxonomy = v$current$tax)
        }
        # --<
        
        v$current$status = list(timing = Sys.time() - initial.time, 
                                msg = paste("Simulated:", nrow(v$current$fossils), "fossil samples"))
        
        session$sendCustomMessage("loading", FALSE)
        
      })
      
      # Clear fossils
      observeEvent(input$clearfossils, {
        v$current$fossils = FossilSim::fossils()
      })
      
      # download simulated data as RData
      output$dldata <- downloadHandler(
        filename = function() {paste0("data-", format(Sys.time(), "%Y-%m-%d_%Hh%Mm%Ss"), ".RData")},
        content = function(file) {
          data = list(tree = v$current$tree, taxonomy = v$current$tax, fossils = v$current$fossils)
          save(data, file = file)
        })
      
      # Input synchronization with data ---
      # When an input is changed run through all of the inputs and grabs the data
      #todo -- implement a more efficient method ie : only grab what was changed
      observe({
        for (inpId in c(allNumericInputs, allCheckboxInputs, allTextInputs)) {
          v$current[[inpId]] = input[[inpId]]
        }
      })
      
      # On tab change, update all inputs to stored data for that tab ---
      observeEvent(v$currentTab, {
        for (ni in allNumericInputs) {
          updateNumericInput(session, ni, value=v$current[[ni]])
        }
        for (ci in allCheckboxInputs) {
          updateCheckboxInput(session, ci, value=v$current[[ci]]) 
        }
      })
    }
  )
}

# Themebar : Lets you change UI theme using a bar with buttons at the bottom right of the application ----
themebar <- function(id) {
  ns <- NS(id)
  
  tagList(
    fixedPanel(
      id = NS(id, "fixed"),
      right = 5,
      bottom = 5,
      width="25%",
      style="text-align : right;"
    ),
    
    # Import Javascript for themebar, you can create/modify themes using www/themeManger.js and www/style.css
    tags$script(src = "themeManager.js")
  )
}

library(shiny)

#todo -- return error if user tries to simulate fossils first
#todo -- non-uniform sometimes makes the app crash - is this still an issue? -> don't think so
#todo -- choose restrictions on parameter values more systematically, turnover, tip number, psi, meanlog, sdlog
#todo -- add additional checks for newick trees, e.g. branch lengths
#todo -- need an error for when you try to draw a reconstructed tree with only one sample
#todo -- how about a help button that says learn more about this model?
#todo -- option to plot complete and reconstructed tree alongside each other?
#todo -- what about an option to output some of the simulated data? or specify the seed

# Main UI --- ---
ui = fluidPage(
  shinyjs::useShinyjs(),
  
  # Import CSS for formatting ---
  tags$link(rel = "stylesheet", type = "text/css", href = "style.css"),
  
  # App title for head ---
  tags$head(HTML("<title>Simulate fossils with FossilSim</title>")),
  
  # Small white space, purely aesthetic ---
  HTML("</br> "),
  
  # Sidebar layout with input and output definitions ---
  sidebarLayout(
    
    # Input panel for inputs ---
    # ./R/inputSidebar.R
    inputSidebarUI("inputSidebar"),
    
    # Main panel for displaying outputs ---
    # ./R/outputSidebar.R
    outputSidebar("outputSidebar"),
    
  ),
  
  # App title ---
  fixedPanel(
    tags$div(class = "app-title", HTML(
      "<h1 id = \"app-title\">F<img id = \"logo\" src = \"logo.png\" style=\"width : 20px;\">ssilSimShiny</h1>"
      )), left = 0, top = 0, width="100%",
  ),
  
  # Small white space, purely aesthetic ---
  HTML("</br> </br> </br> </br> </br> </br>"),
  
  # Tooltip : info bar at the bottom of the application ---
  # ./R/tooltip.R
  tooltip(id = "tooltip"),
  
  # Themebar : buttons to change theme (background color, text color, etc...)
  # ./R/themebar.R
  themebar(id = "themebar")
  
)


# Main Server Function --- ---
server <- function(input, output) {
  shinyjs::showLog()
  
  # Here we create the different keys for our tabs ---
  # Each tab has a key specific to it, this is what allows us to manage our data between tabs
  # If you would like to modify the tab names, you also need to need to modify the initial tab in ./R/outputSidebar.R and currTab in www/saveas.js
  # The "current" key corresponds to the current active tab; do not modify
  # This does not need to be an active variable as keys shouldn't be changed during run time
  keys = c("current", "i", "ii", "iii", "iv", "v")
  
  # Creation of our tab manager ---
  # ./R/toad.R
  tabManager <- toadCreate(keys)

  # InputSidebarServer : Handles all of the inputs and generates data ---
  # ./R/inputSidebar.R
  inputSidebar = inputSidebarServer("inputSidebar", tabManager)
  
  # OutputSidebarServer : Mostly handles output, like generating plots, and some tab managing ---
  # ./R/outputSidebar.R
  outputSidebar = outputSidebarServer("outputSidebar", tabManager, keys)
}

# Run the app --- outdated
shinyApp(ui = ui, server = server)

# Tooltip : info bar at the bottom of the application ----
tooltip <- function(id) {
  tagList(
    fixedPanel(
      p(id = "tooltip", "i : "),
      left = 0,
      bottom = 0,
      height = "40px",
      width="100%",
      style = "background-color: #54aeff; font-size: 16px;",
    ),
    
    # Import Javascript for tooltip, you can add/modify tooltip descriptions in www/tooltip.js
    tags$script(src = "tooltip.js")
  )
}

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----eval=FALSE---------------------------------------------------------------
#  install.packages("FossilSimShiny")

## ----eval=FALSE---------------------------------------------------------------
#  FossiSimShiny::launchFossilSimShiny()

## ----eval=FALSE---------------------------------------------------------------
#  FossiSimShiny::launchFossilSimShiny(FALSE)

## ----echo=FALSE, out.width = "90%", fig.cap = cap-----------------------------
knitr::include_graphics("images/main-menu.png")
cap = "**Fig. 1**. FossilSimShiny main screen."

## ----echo=FALSE, out.width = "90%", fig.cap = cap-----------------------------
knitr::include_graphics("images/main-menu-click-tree.png")
cap = "**Fig. 2**. Clicking the tree tab."

## ----echo=FALSE, out.width = "90%", fig.cap = cap-----------------------------
knitr::include_graphics("images/tree-menu-click-sim.png")
cap = "**Fig. 3**. Generating a tree from set parameters."

## ----echo=FALSE, out.width = "90%", fig.cap = cap-----------------------------
knitr::include_graphics("images/newick.png")
cap = "**Fig. 4**. Importing a premade tree.</br>Newick string used: `owls(((Strix_aluco:4.2,Asio_otus:4.2):3.1, Athene_noctua:7.3):6.3,Tyto_alba:13.5);`."

## ----echo=FALSE, out.width = "90%", fig.cap = cap-----------------------------
knitr::include_graphics("images/main-menu-click-tax.png")
cap = "**Fig. 5**. Clicking the taxonomy tab."

## ----echo=FALSE, out.width = "90%", fig.cap = cap-----------------------------
knitr::include_graphics("images/tax-menu.png")
cap = "**Fig. 6**. Simulating a taxonomy with the default parameters."

## ----echo=FALSE, out.width = "90%", fig.cap = cap-----------------------------
knitr::include_graphics("images/main-menu-click-fos.png")
cap = "**Fig. 7**. Clicking the fossils tab."

## ----echo=FALSE, out.width = "90%", fig.cap = cap-----------------------------
knitr::include_graphics("images/fos-menu.png")
cap = "**Fig. 8**. Generating fossil records for our tree using a uniform distribution."

## ----echo=FALSE, out.width = "90%", fig.cap = cap-----------------------------
knitr::include_graphics("images/going-back-tax.png")
cap = "**Fig. 9**. Going back to the taxonomy view to save it as an image."

## ----echo=FALSE, out.width = "90%", fig.cap = cap-----------------------------
knitr::include_graphics("images/saveas.png")
cap = "**Fig. 10**. Saving our taxonomy as an image."

# Output Sidebar : Fixed sidebar on the left of the app where everything is plotted ----
# Handles changing tabs and switching between graphs (tree, taxonomy, fossils + tree)

# UI/Frontend --- ---
outputSidebar <- function(id) {
  
  # Wrapping our ids ---
  # The NS function allows us to wrap the ids of our ui components
  # This is necessary for nested R modules like this one
  # ns stands for namespace, more info : https://shiny.rstudio.com/articles/modules.html
  ns <- NS(id)
  
  # This is the name of the first tab ---
  # needs to match main.R/keys[2]
  # this is the value to modify if you would like to rename the tabs
  initialTabName = "i"
  
  # Start of our UI ---
  # tagList is the nested version of fluidPage
  tagList(
    fixedPanel(id=ns("saveButtons"),
               downloadButton(ns("saveas"), "Save image as...", icon = shiny::icon("file-export")),
               radioButtons(ns("imgformat"), label = NULL, c("PNG", "PDF"), inline = TRUE),
               top = "60px", left = "33%", width = "67%"),
    
    fixedPanel(id=ns("outputDisplay"),
               
               tabsetPanel(id = ns("outputTabset"),
                           
                           # Initial tab ---
                           tabPanel(
                             
                             initialTabName,
                             
                             # This is the view selector : tree, taxonomy, tree+fossils ---
                             fixedPanel(id = ns(paste0(initialTabName, "fixedview")),
                                        
                                        selectInput(inputId = ns(paste0(initialTabName, "dropview")),
                                                    label="", choices = c("tree", "taxonomy", "tree+fossils")),
                                        top = "60px", right = "5%", width = "15%", height="5vh"),
                             
                             textOutput(outputId = ns(paste0(initialTabName, "msg"))),
                             
                             # Main plot output ---
                             plotOutput(outputId = ns(paste0(initialTabName, "tree")),
                                        width = "100%", height = "80vh"),
                           ),
                           
                           # New tab button ---
                           tabPanel("+", "")
               ),
               
               # Set size of output panel 
               #todo -- make it react to different screen resolution
               left = "33%", top= "120px", bottom = "100px", width = "67%"
    )
  )
}

# Server code --- ---
outputSidebarServer <- function(id, v, k) {
  moduleServer(
    id,
    
    function(input, output, session) {
      
      # Setup ---
      # Getting our namespace
      ns <- NS(id)
      
      # Grabing our keys
      keys = k
      
      # tabManager$createdKeys stores which tab have been created
      # At the start, only "current" and "i" have been created. They correspond to keys[1] and keys[2]
      v$createdKeys = c(keys[1], keys[2])
      
      makePlots = reactive({
        session$sendCustomMessage("loading", FALSE)
        
        validate(need( (v$current$taxonomybeta >= 0 && v$current$taxonomybeta <= 1), "Probability of bifurcation needs to be between 0 and 1"))
        validate(need(is.null(v$current$error) || !v$current$error, v$current$errorMsg))
        
        # Check if there is a tree
        if(is.null(v$current$tree)) return(NA)
        
        # Show fossil taxonomy
        if(v$current$showtaxonomy) {
          validate(need(!is.null(v$current$tax), "Show taxonomy is selected but no taxonomy was found"))
        }
        
        par(oma = c(8, 0, 0, 0))
        # View 1) tree : display tree with empty fossils
        if (input[[paste0(v$currentTab, "dropview")]] == "tree"){
          plot(FossilSim::fossils(),
               v$current$tree,
               taxonomy = v$current$tax,
               show.tree = v$current$showtree,
               show.ranges = v$current$showranges,
               show.fossils = v$current$showfossils,
               show.strata = v$current$showstrata,
               show.taxonomy = v$current$showtaxonomy,
               reconstructed = v$current$reconstructed,
               show.tip.label = v$current$showtips,
               align.tip.label = TRUE)
        }
        
        # View 2) taxonomy : displays the generated taxonomy
        if (input[[paste0(v$currentTab, "dropview")]] == "taxonomy"){
          validate(need(!is.null(v$current$tax), "No taxonomy found, please simulate a taxomony."))
          validate(need(all(v$current$tree$edge %in% v$current$tax$edge), "Taxonomy incompatible with tree, please resimulate taxonomy."))
          
          plot(v$current$tax, v$current$tree, legend.position = "bottomleft",
               show.tip.label = v$current$showtips,
               align.tip.label = TRUE)
        }
        
        # View 3) tree+fossils : displays the tree with the fossils on top
        if (input[[paste0(v$currentTab, "dropview")]] == "tree+fossils") {
          validate(need(!is.null(v$current$fossils), "No fossils found, please simulate fossils."))
          
          is.enviro.model = !is.null(v$current$fossilModelName) && v$current$fossilModelName == "Holland"
          show.depth = (v$current$`enviro-dep-showsamplingproxy` && is.enviro.model)
          strata = if((v$current$showstrata || v$current$`enviro-dep-showsamplingproxy`) && is.enviro.model) v$current$strata else 1
          int.ages = if(v$current$showstrata && (!is.null(v$current$fossilModelName) && v$current$fossilModelName == "Non-Uniform")) v$current$int.ages else NULL
          
          plot(v$current$fossils,
               v$current$tree,
               taxonomy = v$current$tax,
               show.tree = v$current$showtree,
               show.ranges = v$current$showranges,
               show.fossils = v$current$showfossils,
               show.strata = v$current$showstrata,
               show.taxonomy = v$current$showtaxonomy,
               
               # Only for Holland 95
               show.proxy = show.depth,
               proxy.data = v$current$wd,
               strata = strata,
               
               # Only for time-dependent
               interval.ages = int.ages,
               
               reconstructed = v$current$reconstructed,
               show.tip.label = v$current$showtips,
               align.tip.label = TRUE)
        }
        recordPlot()
      })
      
      # Displaying plots ---
      
      # for every tab
      for (k in keys) {
        output[[paste0(k,"msg")]] <- renderText({
          msg = if(!is.null(v$current$status) && v$current$status$timing > 0) paste("Simulation time:", round(v$current$status$timing, digits = 3), "seconds") else ""
          if(!is.null(v$current$status) && v$current$status$msg != "") msg = paste(msg, "-", v$current$status$msg)
          msg
        })
        
        # update the tab's plot if input values have changed
        # in reality only $current plot will ever be changed
        output[[paste0(k,"tree")]] <- renderPlot({ makePlots() })
      }
      
      # Dropdown/View selector ----
      # Priority is very important (last to first)
      # First is the tree view which gets triggered when the tree data is changed, ie : when the user simulates a tree 
      observeEvent(v$current$tree, {
        updateSelectInput(session, paste0(v$currentTab, "dropview"), selected = "tree")
      })
      # Second is the taxonomy view, same mechanism
      observeEvent(v$current$tax, {
        if (!is.null(v$current$tax) && all(v$current$tree$edge %in% v$current$tax$edge)) {
          updateSelectInput(session, paste0(v$currentTab, "dropview"), selected = "taxonomy")
        }
      })
      # Last is the fossil+tree view
      observeEvent(v$current$fossils, {
        if (length(v$current$fossils$sp) != 0) {
          updateSelectInput(session, paste0(v$currentTab, "dropview"), selected = "tree+fossils")
        }
      })
      
      
      # Change/create new tabs ---
      observeEvent(input$outputTabset, {
        
        # Create new tab when the "+" tab is clicked --
        if (input$outputTabset == "+") {
          
          # The following code can be a bit confusing, so, I have decided to comment it extensively --
          
          # First, save the current tab
          v[[v$currentTab]] = v$current
          
          # Then, get a new key from the available keys for the new tab
          v$currentTab = toadNewTabKey(keys, v$createdKeys)
          
          # Add this new key to the list of used keys, so it doesn't get used twice
          v$createdKeys = append(v$createdKeys, v$currentTab)
          
          # Switch the current tab value to the newly created one
          v$current = v[[v$currentTab]]
          
          # --<
          
          # Create tab
          # same layout as the initial tab
          # each component has an id consisting of it's tab id and it's component name
          # ex : for the tab "ii", the component "dropview" is named "iidropview"
          insertTab(inputId = "outputTabset",
                    
                    tabPanel(title = v$currentTab,
                             
                             fixedPanel(id = ns(paste0(v$currentTab, "fixedview")),
                                        
                                        selectInput(inputId = ns(paste0(v$currentTab, "dropview")),
                                                    label="", choices = c("tree", "taxonomy", "tree+fossils")),
                                        top = "60px", right = "5%", width = "15%", height="5vh"),
                             
                             textOutput(outputId = ns(paste0(v$currentTab, "msg"))),
                             
                             plotOutput(outputId = ns(paste0(v$currentTab, "tree")),
                                        width = "100%", height = "80vh")), target = "+", position="before")
          
          # If all of the tab keys have been used, we delete the "+" tab
          if (v$createdKeys[length(v$createdKeys)] == keys[length(keys)]) {
            removeTab(inputId = "outputTabset", target = "+")
          }
          
          # Set the new tab as selected in the UI
          updateTabsetPanel(session, "outputTabset", v$currentTab)
        }
        
        # Change tab --
        else {
          v[[v$currentTab]] = v$current
          v$currentTab = input$outputTabset
          v$current = v[[v$currentTab]]
        }
      })
      
      output$saveas <- downloadHandler(
        filename = function() {
          if(input$imgformat == "PNG") paste0("plot_", format(Sys.time(), "%Y-%m-%d_%Hh%Mm%Ss"), ".png")
          else paste0("plot_", format(Sys.time(), "%Y-%m-%d_%Hh%Mm%Ss"), ".pdf")
        },
        content = function(file) {
          if(input$imgformat == "PNG") png(file, width = 2500, height = 1500)
          else pdf(file, width = 20, height = 15)
          plot = makePlots()
          if(length(plot) > 1 || !is.na(plot)) replayPlot(plot)
          dev.off()
        })
    }
  )
}

# t.o.a.d. = Tab manager
# set of functions that help us manage our tabs

# Creates a new tab manager
toadCreate <- function(keys) {
  toad = reactiveValues()
  
  for (key in keys) {
    toad[[key]] = list(tree = NULL, fossils = FossilSim::fossils())
  }
  
  toad$currentTab = "v"
  return(toad)
}

# Returns the current tab
# only used for debugging
toadGetCurrentTab <- function(toad) {
  return(toad[[toad$currentTab]])
}

# Returns the next tab's key
# only used for debugging
toadNextTabKey <- function(toad, keys) {
  for (i in 1:(length(keys)-1)) {
    if (toad$currentTab == keys[i]) {
      return(keys[i + 1])
    }
  }
  
  toad$currentTab = keys[2]
  return(toad$currentTab)
}

# Return the new tab's key
toadNewTabKey <- function(keys, Ckeys) {
  for (k in keys) {
    if (!(k %in% Ckeys)) {
      return(k)
    }
  }
}

---
title: "How to use the 'FossilSimShiny' app: a basic guide of the main functionalities"
author: "Titouan Chambe"
date: "`r Sys.Date()`"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{User guide}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

This vignette provides information on how to use the `FossilSimShiny` application to perform simple tasks.

## Contents

* [Launching the app]
* [Phylogenetic Tree]
  * [Generating a Tree]
  * [Importing a tree from Newick format]
* [Generating Taxonomy]
* [Simulating Fossils]
* [Saving your tree as a `.png`]
* [Last Words]
* [Additional Information]

## Launching the app

Let's dive right in.\
\
Once you have installed the `FossilSimShiny` package,\
\
```{r, eval=FALSE}
install.packages("FossilSimShiny")
```
\
Simply use the command:\

```{r, eval=FALSE}
FossiSimShiny::launchFossilSimShiny()
```
\
This should launch the application in your preferred browser.\
\
If you are using `RStudio` and you want to launch the app inside `RStudio's` browser, you can instead use:\

```{r, eval=FALSE}
FossiSimShiny::launchFossilSimShiny(FALSE)
```
\
```{r echo=FALSE, out.width = "90%", fig.cap = cap}
knitr::include_graphics("images/main-menu.png")
cap = "**Fig. 1**. FossilSimShiny main screen."
```

## Phylogenetic Tree

### Generating a tree

To generate a tree, start by opening the tree tab by clicking on the **tree** tab.\
\
```{r echo=FALSE, out.width = "90%", fig.cap = cap}
knitr::include_graphics("images/main-menu-click-tree.png")
cap = "**Fig. 2**. Clicking the tree tab."
```
\
A new menu should appear. Inside this menu, you can set different tree parameters:\

* Specialization rate

* Extinction rate

* Tip number

Once you are happy with the parameters you have set, press the **simulate tree** button to generate a tree.\
\
```{r echo=FALSE, out.width = "90%", fig.cap = cap}
knitr::include_graphics("images/tree-menu-click-sim.png")
cap = "**Fig. 3**. Generating a tree from set parameters."
```

### Importing a tree from Newick format

To use your own trees, simply tick the user tree check box and paste your `Newick` string inside the designated text box below.\
\
```{r echo=FALSE, out.width = "90%", fig.cap = cap}
knitr::include_graphics("images/newick.png")
cap = "**Fig. 4**. Importing a premade tree.</br>Newick string used: `owls(((Strix_aluco:4.2,Asio_otus:4.2):3.1, Athene_noctua:7.3):6.3,Tyto_alba:13.5);`."
```
\
Since the app uses the `ape::read.tree()` function from the `ape` package. Look 
<a href = "https://www.rdocumentation.org/packages/ape/versions/5.6-2/topics/read.tree">here</a> 
for more information on how to format your trees.

## Generating Taxonomy

**Once you have a phylogenetic tree,** you can generate it's taxonomy.\

*Note: if do not have a tree generated, go back to [Phylogenetic Tree].*\
\
Open the taxonomy menu by clicking on the **taxonomy** tab.\
\
```{r echo=FALSE, out.width = "90%", fig.cap = cap}
knitr::include_graphics("images/main-menu-click-tax.png")
cap = "**Fig. 5**. Clicking the taxonomy tab."
```
\
Inside you can set different parameters:\

* Probability of symmetric speciation 

* Rate of anagenesis

When everything is set, press the **simulate taxonomy** button.\
\
```{r echo=FALSE, out.width = "90%", fig.cap = cap}
knitr::include_graphics("images/tax-menu.png")
cap = "**Fig. 6**. Simulating a taxonomy with the default parameters."
```

## Simulating Fossils

**Once you have a phylogenetic tree,** you can immediately simulate fossil records.\

*Note: if do not have a tree generated, go back to [Phylogenetic Tree]. Furthermore, if you wish to use a lineage-dependent model to simulate your fossils, it is recommended to generate the taxonomy first. Go to [Generating Taxonomy].*\
\
First, click on the **fossils** tab.\
\
```{r echo=FALSE, out.width = "90%", fig.cap = cap}
knitr::include_graphics("images/main-menu-click-fos.png")
cap = "**Fig. 7**. Clicking the fossils tab."
```
\
In the fossils tab, you must choose which model you would like to use to simulate your fossil records. Each one of them has their own peculiarities:\

* Uniform
* Non-uniform
* Environment-dependent
* Lineage-dependent

\
```{r echo=FALSE, out.width = "90%", fig.cap = cap}
knitr::include_graphics("images/fos-menu.png")
cap = "**Fig. 8**. Generating fossil records for our tree using a uniform distribution."
```

## Saving your tree as a `.png`

Use the **drop down** in the top left corner of the app to select the plot that you would like to save.\
As an example, let's save a picture of our taxonomy.\
\
```{r echo=FALSE, out.width = "90%", fig.cap = cap}
knitr::include_graphics("images/going-back-tax.png")
cap = "**Fig. 9**. Going back to the taxonomy view to save it as an image."
```
\
Then, just press the **save tree as image...** button.\
\
```{r echo=FALSE, out.width = "90%", fig.cap = cap}
knitr::include_graphics("images/saveas.png")
cap = "**Fig. 10**. Saving our taxonomy as an image."
```
\
Your plot should get saved as a `.png` to your `/downloads` folder.\

## Last words

And voilà ! You know all the basics and can now generate your own trees, taxonomy and fossil records.\
If you would like to dive a bit deeper into more advanced functionalities check out (COMING SOON).\

## Additional information
All screenshots in this guide were taken on the **Google Chrome** browser using the built in `screenshot` command.\
\
**Dimensions:** 1024x1024 75%, **Output:** 2048x2048, **Resized to:** 2048x2048.\

---
title: "Hosting 'FossilSimShiny' on a Web Server"
author: "Titouan Chambe"
date: "`r Sys.Date()`"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Hosting FossilSimShiny on a Web Server}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  fig.width = 5, fig.height = 5
)
```

This vignette provides information on how to host the `FossilShinyApp` on a web server.\
\
Specifically, while we'll only look at serving the app on `Debian 11`, this guide can easily be adapted for any `Linux` based web server and for any app for that matter.\

## Contents
* [Preface]
* [Dependencies]
  * [R]
  * [Dependencies for building a Shiny server from source]
  * [R packages we need]
* [Installing Shiny Server]
* [Putting the app on the server]
* [Firewall tweaks]
* [Starting Shiny Server]

## Preface

This guide will assume you know basic `bash` commands and have already setup a `ssh` connection to your web server.

## Dependencies

Let's start by installing all the dependencies we'll need to compile and run our shiny web server.
Connect via `ssh` to your web server and install the following packages.

### R

Some dependencies used by `FossilSim` require a rather recent version of `R`. At the time of making this, on `debian bullseye`, you need a newer version of R rather than the one supplied by the advanced packaging tool `apt`.\
\
This means we'll need to add a `PPA` in order to get a more recent version of `R` as to fully support the `FossilSim` package, which we obviously need.\
\
First open the file at `/etc/apt/sources.list` to add the `R` `PPA` to your sources list:
\
```{bash, eval = FALSE}
nano /etc/apt/sources.list
```

Add the line `deb http://cloud.r-project.org/bin/linux/debian bullseye-cran40/` as shown below to add the `PPA`.\
\
If you are using a different `distro`, you can use https://CRAN.R-project.org/bin/linux/ to find the right `PPA`.\
\
Your source file should look like this:

```{bash, eval = FALSE}
# deb http://mirrors.online.net/debian bullseye main

deb http://mirrors.online.net/debian bullseye main non-free contrib
deb-src http://mirrors.online.net/debian bullseye main non-free contrib

deb http://security.debian.org/debian-security bullseye-security main contrib n>
deb-src http://security.debian.org/debian-security bullseye-security main contr>

# R 4.2.0
deb http://cloud.r-project.org/bin/linux/debian bullseye-cran40/
```

Then press `CTRL+X` to quit and `Y` to save.\
\
Finally, you can install `R`.

```{bash, eval = FALSE}
apt-get update
apt-get install r-base r-base-dev
```

You can verify your `R` version by using the `R` command.

```{bash, eval = FALSE}
$ R

R version 4.2.0 (2022-04-22) -- "Vigorous Calisthenics"
```

### Dependencies for building a Shiny server from source

These are the dependencies you'll need to build shiny server. Depending on your distribution they may already be pre-installed.\
\

* `Python 3.6+`, pre-installed on `Debian 11`.

Use `which python3` to verify it is installed. You should get something like `/usr/bin/python3` if it's correctly installed.


* `cmake`

Use `sudo apt-get install cmake`.


* `gcc`

Should be pre-installed.</br>
*Author's note: we need *`gcc 4.8`*or newer which means you cannot use this guide with a*`Debian 9<`*server.*

* `g++`

Should be pre-installed.


* `git`

Use `sudo apt-get install git`.

### R packages we need

Any `R` packages used by the app needs to be installed for all users.
This means we need to install both the shiny package and the `FossilSim` package for all users.

```{bash, eval = FALSE}
sudo su - -c "R -e \"install.packages('shiny', repos='https://cran.rstudio.com/')\""
sudo su - -c "R -e \"install.packages('FossilSim')\""
```

## Installing Shiny Server

**Note:** most of this part is referenced from <a href="https://github.com/rstudio/shiny-server/wiki/Building-Shiny-Server-from-Source">here</a>.\
\
Once all of the prerequisites have been satisfied, you can use the following commands to download and install Shiny Server.

```{bash, eval = FALSE}
# Clone the repository from GitHub
git clone https://github.com/rstudio/shiny-server.git

# Get into a temporary directory in which we'll build the project
cd shiny-server
mkdir tmp
cd tmp

# Install our private copy of Node.js
../external/node/install-node.sh

# Add the bin directory to the path so we can reference node
DIR=`pwd`
PATH=$DIR/../bin:$PATH

# Use cmake to prepare the make step. Modify the "--DCMAKE_INSTALL_PREFIX"
# if you wish the install the software at a different location.
cmake -DCMAKE_INSTALL_PREFIX=/usr/local ../
# Get an error here? Check the "How do I set the cmake Python version?" question below

# Compile native code and install npm dependencies
make
mkdir ../build
(cd .. && ./bin/npm install)

# Install the software at the predefined location
sudo make install

# Install default config file
sudo mkdir -p /etc/shiny-server
sudo cp ../config/default.config /etc/shiny-server/shiny-server.conf

# Place a shortcut to the shiny-server executable in /usr/bin
sudo ln -s /usr/local/shiny-server/bin/shiny-server /usr/bin/shiny-server

# Create shiny user. On some systems, you may need to specify the full path to 'useradd'
sudo useradd -r -m shiny

# Create log, config, and application directories
sudo mkdir -p /var/log/shiny-server
sudo mkdir -p /srv/shiny-server
sudo mkdir -p /var/lib/shiny-server
sudo chown shiny /var/log/shiny-server
sudo mkdir -p /etc/shiny-server

# I added this command
sudo chown shiny:shiny /var/lib/shiny-server/

```

## Putting the app on the server

The `/srv/shiny-server` directory is where we house our apps.</br>
I recommend creating a new directory: `/srv/shiny-server/FossilSimShinyApp/`.

Then, you can grab the `app.R` file, the `/www/` folder and the `/R/` folder from <a href = "https://github.com/fossilsim/FossilSimShiny/tree/master/inst/shinyApp">here</a> and copy them to `/srv/shiny-server/FossilSimShinyApp/`.

## Firewall tweaks

By default, Shiny Server is set to use port **3838**.</br> *Author's note: I have no idea why they chose this port.*\
\
You'll need to open the port.\
\
If you are using uncomplicated firewall, you can run the command: `sudo ufw allow 3838`

Furthermore you can change the port used in `/etc/shiny-server/shiny-server.conf`.

## Starting Shiny Server

As you probably noticed, during the installation, we created a new user called shiny.
We'll use this user to start and stop our shiny operations.

Let's start our shiny server. First, log in as shiny.
```{bash, eval = FALSE}
su shiny
```

If you've followed everything correctly, you should be able to start the shiny server by typing:
```{bash, eval = FALSE}
shiny-server
```

```{bash, eval = FALSE}
[2022-05-10T13:56:44.320] [INFO] shiny-server - Shiny Server v1.5.19.0 (Node.js v16.14.0)
[2022-05-10T13:56:44.324] [INFO] shiny-server - Using config file "/etc/shiny-server/shiny-server.conf"
[2022-05-10T13:56:44.435] [INFO] shiny-server - Starting listener on http://[::]:3838
```

You should then be able to access your app using any web browser and going to the following web address:

```{bash, eval = FALSE}
http:// your ip address :3838/FossilSimShiny/
```


## Further Reading

* <a href="https://docs.posit.co/shiny-server/">Administrative guide to shiny server</a>

\
\
